Loading...
Searching...
No Matches
mongocxx::v1::auto_encryption_options Class Reference

`#include <mongocxx/v1/auto_encryption_options.hpp>`

## Description

Options related In-Use Encryption configuration.

Supported fields include:

- bypass_auto_encryption ("bypassAutoEncryption")
- bypass_query_analysis ("bypassQueryAnalysis")
- encrypted_fields_map ("encryptedFieldsMap")
- extra_options ("extraOptions")
- key_vault_client ("keyVaultClient")
- key_vault_namespace ("keyVaultNamespace")
- key_vault_pool ("keyVaultPool")
- kms_providers ("kmsProviders")
- schema_map ("schemaMap")
- tls_options ("tlsOptions")

See also
  - MongoClient Options for Queryable Encryption (MongoDB Manual)
  - MongoClient Options for CSFLE

## Public Types

using | ns_pair = std::pair<std::string, std::string>
| The name of a database and a collection.

## Public Member Functions

| auto_encryption_options ()
| Default initialization.
| auto_encryption_options (auto_encryption_options &&other) noexcept
| Move constructor.
| auto_encryption_options (auto_encryption_options const &other)
| Copy construction.
| ~auto_encryption_options ()
| Destroy this object.
bool | bypass_auto_encryption () const
| Return the current "bypassAutoEncryption" field.
auto_encryption_options & | bypass_auto_encryption (bool v)
| Set the "bypassAutoEncryption" field.
bool | bypass_query_analysis () const
| Return the current "bypassQueryAnalysis" field.
auto_encryption_options & | bypass_query_analysis (bool v)
| Set the "bypassQueryAnalysis" field.
bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > | encrypted_fields_map () const
| Return the current "encryptedFieldsMap" field.
auto_encryption_options & | encrypted_fields_map (bsoncxx::v1::document::value v)
| Set the "encryptedFieldsMap" field.
bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > | extra_options () const
| Return the current "extraOptions" field.
auto_encryption_options & | extra_options (bsoncxx::v1::document::value v)
| Set the "extraOptions" field.
v1::client * | key_vault_client () const
| Return the current "keyVaultClient" field.
auto_encryption_options & | key_vault_client (v1::client *v)
| Set the "keyVaultClient" field.
bsoncxx::v1::stdx::optional< ns_pair > | key_vault_namespace () const
| Return the current "keyVaultNamespace" field.
auto_encryption_options & | key_vault_namespace (ns_pair v)
| Set the "keyVaultNamespace" field.
v1::pool * | key_vault_pool () const
| Return the current "keyVaultPool" field.
auto_encryption_options & | key_vault_pool (v1::pool *v)
| Set the "keyVaultPool" field.
bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > | kms_providers () const
| Return the current "kmsProviders" field.
auto_encryption_options & | kms_providers (bsoncxx::v1::document::value v)
| Set the "kmsProviders" field.
auto_encryption_options & | operator= (auto_encryption_options &&other) noexcept
| Move assignment.
auto_encryption_options & | operator= (auto_encryption_options const &other)
| Copy assignment.
bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > | schema_map () const
| Return the "schemaMap" field.
auto_encryption_options & | schema_map (bsoncxx::v1::document::value v)
| Set the "schemaMap" field.
bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > | tls_opts () const
| Return the current "tlsOptions" field.
auto_encryption_options & | tls_opts (bsoncxx::v1::document::value v)
| Set the "tlsOptions" field.

## Member Typedef Documentation

## ns_pair

using mongocxx::v1::auto_encryption_options::ns_pair = std::pair<std::string, std::string>

The name of a database and a collection.

ns_pair{"db", "coll"} // db.coll
mongocxx::v1::auto_encryption_options::ns_pair
std::pair< std::string, std::string > ns_pair
The name of a database and a collection.
Definition auto_encryption_options.hpp:146

## Constructor & Destructor Documentation

## ~auto_encryption_options()

mongocxx::v1::auto_encryption_options::~auto_encryption_options | ( |  | ) |

Destroy this object.

Warning
  Invalidates all associated views.

## auto_encryption_options() [1/3]

mongocxx::v1::auto_encryption_options::auto_encryption_options | ( | auto_encryption_options && | other | ) |

noexcept

Move constructor.

Postconditions:
  - other is in an assign-or-destroy-only state.

## auto_encryption_options() [2/3]

mongocxx::v1::auto_encryption_options::auto_encryption_options | ( | auto_encryption_options const & | other | ) |

Copy construction.

## auto_encryption_options() [3/3]

mongocxx::v1::auto_encryption_options::auto_encryption_options | ( |  | ) |

Default initialization.

Postconditions:
  - All supported fields are "unset" or zero-initialized.

## Member Function Documentation

## bypass_auto_encryption() [1/2]

bool mongocxx::v1::auto_encryption_options::bypass_auto_encryption | ( |  | ) | const

Return the current "bypassAutoEncryption" field.

## bypass_auto_encryption() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::bypass_auto_encryption | ( | bool | v | ) |

Set the "bypassAutoEncryption" field.

## bypass_query_analysis() [1/2]

bool mongocxx::v1::auto_encryption_options::bypass_query_analysis | ( |  | ) | const

Return the current "bypassQueryAnalysis" field.

## bypass_query_analysis() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::bypass_query_analysis | ( | bool | v | ) |

Set the "bypassQueryAnalysis" field.

## encrypted_fields_map() [1/2]

bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > mongocxx::v1::auto_encryption_options::encrypted_fields_map | ( |  | ) | const

Return the current "encryptedFieldsMap" field.

## encrypted_fields_map() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::encrypted_fields_map | ( | bsoncxx::v1::document::value | v | ) |

Set the "encryptedFieldsMap" field.

## extra_options() [1/2]

bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > mongocxx::v1::auto_encryption_options::extra_options | ( |  | ) | const

Return the current "extraOptions" field.

## extra_options() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::extra_options | ( | bsoncxx::v1::document::value | v | ) |

Set the "extraOptions" field.

## key_vault_client() [1/2]

v1::client * mongocxx::v1::auto_encryption_options::key_vault_client | ( |  | ) | const

Return the current "keyVaultClient" field.

## key_vault_client() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::key_vault_client | ( | v1::client * | v | ) |

Set the "keyVaultClient" field.

Important
  The associated client MUST outlive any client or pool configured to use this option.

Note
  The "keyVaultClient" and "keyVaultPool" fields are mutually exclusive.

Parameters

  v | Equivalent to "unset" when null.

## key_vault_namespace() [1/2]

bsoncxx::v1::stdx::optional< ns_pair > mongocxx::v1::auto_encryption_options::key_vault_namespace | ( |  | ) | const

Return the current "keyVaultNamespace" field.

## key_vault_namespace() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::key_vault_namespace | ( | ns_pair | v | ) |

Set the "keyVaultNamespace" field.

## key_vault_pool() [1/2]

v1::pool * mongocxx::v1::auto_encryption_options::key_vault_pool | ( |  | ) | const

Return the current "keyVaultPool" field.

## key_vault_pool() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::key_vault_pool | ( | v1::pool * | v | ) |

Set the "keyVaultPool" field.

Equivalent to "keyVaultClient", but acquires a client from the given pool on-demand.

Important
  The associated pool MUST outlive any client or pool configured to use this option.

Note
  The "keyVaultClient" and "keyVaultPool" fields are mutually exclusive.

Parameters

  v | Equivalent to "unset" when null.

## kms_providers() [1/2]

bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > mongocxx::v1::auto_encryption_options::kms_providers | ( |  | ) | const

Return the current "kmsProviders" field.

## kms_providers() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::kms_providers | ( | bsoncxx::v1::document::value | v | ) |

Set the "kmsProviders" field.

## operator=() [1/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::operator= | ( | auto_encryption_options && | other | ) |

noexcept

Move assignment.

Postconditions:
  - other is in an assign-or-destroy-only state.

## operator=() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::operator= | ( | auto_encryption_options const & | other | ) |

Copy assignment.

## schema_map() [1/2]

bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > mongocxx::v1::auto_encryption_options::schema_map | ( |  | ) | const

Return the "schemaMap" field.

## schema_map() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::schema_map | ( | bsoncxx::v1::document::value | v | ) |

Set the "schemaMap" field.

## tls_opts() [1/2]

bsoncxx::v1::stdx::optional< bsoncxx::v1::document::view > mongocxx::v1::auto_encryption_options::tls_opts | ( |  | ) | const

Return the current "tlsOptions" field.

## tls_opts() [2/2]

auto_encryption_options & mongocxx::v1::auto_encryption_options::tls_opts | ( | bsoncxx::v1::document::value | v | ) |

Set the "tlsOptions" field.

The documentation for this class was generated from the following file:

- mongocxx/v1/auto_encryption_options.hpp